# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.batch_item_key import tBatchItemKey
from bs_monitor.db.tables.batch_item import tBatchItem

class dBatchItemSelectOne:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tBatchItemKey()
        self.orec     = tBatchItem()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  id: int,
                  batch_id: int) -> "dBatchItemSelectOne":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :param batch_id: int
        :return: Self for convenience.
        """
        self.irec.id = id
        self.irec.batch_id = batch_id

        return self.exec()

    def exec(self, irec: tBatchItemKey = None) -> "dBatchItemSelectOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("BatchItemSelectOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  batch_id,
  job_id,
  extra_args,
  stamp_by,
  stamp_tm
from
  monitor.BatchItem
where
  id = :id and
  batch_id = :batch_id""")

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)
        self._dbstmnt.bind_in("batch_id", self.irec.batch_id, int, 8)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("batch_id", int, 8)
        self._dbstmnt.bind_out("job_id", int, 8)
        self._dbstmnt.bind_out("extra_args", str, 128)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.batch_id = self._dbstmnt.result[1]
        self.orec.job_id = self._dbstmnt.result[2]
        self.orec.extra_args = self._dbstmnt.result[3]
        self.orec.stamp_by = self._dbstmnt.result[4]
        self.orec.stamp_tm = self._dbstmnt.result[5]

        return True

    def fetch_all(self, outList: tBatchItem.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

