# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_with_latest_inst import iBatchWithLatestInst
from bs_monitor.db.tables.batch import tBatch
from bs_monitor.db.tables.batch_inst import tBatchInst
from bs_monitor.db.tables.obatch_with_latest_inst import oBatchWithLatestInst

class dBatchWithLatestInst:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchWithLatestInst()
        self.orec     = oBatchWithLatestInst()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  criteria: str,
                  limoff: str) -> "dBatchWithLatestInst":
        """
        Execute the query by setting all the inputs.

        :param criteria: str
        :param limoff: str
        :return: Self for convenience.
        """
        self.irec.criteria = criteria
        self.irec.limoff = limoff

        return self.exec()

    def exec(self, irec: iBatchWithLatestInst = None) -> "dBatchWithLatestInst":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("BatchWithLatestInst", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  b.*,
  i.*
from
  monitor.batch b
    left join
  (
    select
      max(id) as id,
      batch_id
    from
      monitor.batchinst
    group by
      batch_id
  ) l
    on l.batch_id = b.id
    left join
  monitor.batchinst i
    on i.id = l.id and i.batch_id = l.batch_id
where
  (1=1)
  [criteria]
order by
  b.name
[limoff]""")

        self._dbstmnt.dynamic("[criteria]", self.irec.criteria)
        self._dbstmnt.dynamic("[limoff]", self.irec.limoff)

        self._dbstmnt.bind_out("brec_id", int, 8)
        self._dbstmnt.bind_out("brec_parent_id", int, 8)
        self._dbstmnt.bind_out("brec_name", str, 256)
        self._dbstmnt.bind_out("brec_group_id", str, 128)
        self._dbstmnt.bind_out("brec_status", str, 1)
        self._dbstmnt.bind_out("brec_cycle", str, 1)
        self._dbstmnt.bind_out("brec_run_date", datetime.datetime)
        self._dbstmnt.bind_out("brec_run_interval", int, 4)
        self._dbstmnt.bind_out("brec_run_time", str, 6)
        self._dbstmnt.bind_out("brec_ext_data", dict)
        self._dbstmnt.bind_out("brec_stamp_by", str, 128)
        self._dbstmnt.bind_out("brec_stamp_tm", datetime.datetime)
        self._dbstmnt.bind_out("irec_id", int, 8)
        self._dbstmnt.bind_out("irec_parent_id", int, 8)
        self._dbstmnt.bind_out("irec_batch_id", int, 8)
        self._dbstmnt.bind_out("irec_status", str, 1)
        self._dbstmnt.bind_out("irec_run_date", datetime.datetime)
        self._dbstmnt.bind_out("irec_start_date", datetime.datetime)
        self._dbstmnt.bind_out("irec_end_date", datetime.datetime)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.brec.id = self._dbstmnt.result[0]
        self.orec.brec.parent_id = self._dbstmnt.result[1]
        self.orec.brec.name = self._dbstmnt.result[2]
        self.orec.brec.group_id = self._dbstmnt.result[3]
        self.orec.brec.status = self._dbstmnt.result[4]
        self.orec.brec.cycle = self._dbstmnt.result[5]
        self.orec.brec.run_date = self._dbstmnt.result[6]
        self.orec.brec.run_interval = self._dbstmnt.result[7]
        self.orec.brec.run_time = self._dbstmnt.result[8]
        self.orec.brec.ext_data = self._dbstmnt.result[9]
        self.orec.brec.stamp_by = self._dbstmnt.result[10]
        self.orec.brec.stamp_tm = self._dbstmnt.result[11]
        self.orec.irec.id = self._dbstmnt.result[12]
        self.orec.irec.parent_id = self._dbstmnt.result[13]
        self.orec.irec.batch_id = self._dbstmnt.result[14]
        self.orec.irec.status = self._dbstmnt.result[15]
        self.orec.irec.run_date = self._dbstmnt.result[16]
        self.orec.irec.start_date = self._dbstmnt.result[17]
        self.orec.irec.end_date = self._dbstmnt.result[18]

        return True

    def fetch_all(self, outList: oBatchWithLatestInst.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

