# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ijob_inst_metric_by_job_inst import iJobInstMetricByJobInst
from bs_monitor.db.tables.job_inst_metric import tJobInstMetric

class dJobInstMetricByJobInst:

    def __init__(self, dbcon: mettle.db.IConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iJobInstMetricByJobInst()
        self.orec     = tJobInstMetric()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    def exec_deft(self,
                  jobinst_id: int,
                  limoff: str) -> "dJobInstMetricByJobInst":
        """
        Execute the query by setting all the inputs.

        :param jobinst_id: int
        :param limoff: str
        :return: Self for convenience.
        """
        self.irec.jobinst_id = jobinst_id
        self.irec.limoff = limoff

        return self.exec()

    def exec(self, irec: iJobInstMetricByJobInst = None) -> "dJobInstMetricByJobInst":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = self._dbcon.statement("JobInstMetricByJobInst", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  jm.*
from
  monitor.jobinstmetric jm
where
  jm.jobinst_id = :jobinstId
order by
  jm.stamp_tm desc
[limoff]""")

        self._dbstmnt.dynamic("[limoff]", self.irec.limoff)

        self._dbstmnt.bind_in("jobinstId", self.irec.jobinst_id, int, 8)

        self._dbstmnt.bind_out("jobinst_id", int, 8)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)
        self._dbstmnt.bind_out("mtype", str, 1)
        self._dbstmnt.bind_out("msg", str)

        self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.jobinst_id = self._dbstmnt.result[0]
        self.orec.stamp_tm = self._dbstmnt.result[1]
        self.orec.mtype = self._dbstmnt.result[2]
        self.orec.msg = self._dbstmnt.result[3]

        return True

    def fetch_all(self, outList: tJobInstMetric.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

