# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.ibatch_inst_search import iBatchInstSearch
from bs_monitor.db.tables.batch_inst import tBatchInst

class dBatchInstSearch:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = iBatchInstSearch()
        self.orec     = tBatchInst()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        date_from: datetime.datetime,
                        date_to: datetime.datetime,
                        criteria: str,
                        limoff: str) -> "dBatchInstSearch":
        """
        Execute the query by setting all the inputs.

        :param date_from: datetime.datetime
        :param date_to: datetime.datetime
        :param criteria: str
        :param limoff: str
        :return: Self for convenience.
        """
        self.irec.date_from = date_from
        self.irec.date_to = date_to
        self.irec.criteria = criteria
        self.irec.limoff = limoff

        return await self.exec()

    async def exec(self, irec: iBatchInstSearch = None) -> "dBatchInstSearch":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchInstSearch", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  bi.*
from
  monitor.batchinst bi
where
  (cast(:dateFrom as timestamp) is null or  bi.run_date >= :dateFrom) and
  (cast(:dateTo   as timestamp) is null or  bi.run_date <= :dateTo)
  [criteria]
order by
  bi.run_date desc
[limoff]""")

        self._dbstmnt.dynamic("[criteria]", self.irec.criteria)
        self._dbstmnt.dynamic("[limoff]", self.irec.limoff)

        self._dbstmnt.bind_in("dateFrom", self.irec.date_from, datetime.datetime)
        self._dbstmnt.bind_in("dateTo", self.irec.date_to, datetime.datetime)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("parent_id", int, 8)
        self._dbstmnt.bind_out("batch_id", int, 8)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("run_date", datetime.datetime)
        self._dbstmnt.bind_out("start_date", datetime.datetime)
        self._dbstmnt.bind_out("end_date", datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.batch_id = self._dbstmnt.result[2]
        self.orec.status = self._dbstmnt.result[3]
        self.orec.run_date = self._dbstmnt.result[4]
        self.orec.start_date = self._dbstmnt.result[5]
        self.orec.end_date = self._dbstmnt.result[6]

        return True

    async def fetch_all(self, outList: tBatchInst.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

