# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.batch_key import tBatchKey
from bs_monitor.db.tables.batch import tBatch

class dBatchLockOne:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tBatchKey()
        self.orec     = tBatch()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        id: int) -> "dBatchLockOne":
        """
        Execute the query by setting all the inputs.

        :param id: int
        :return: Self for convenience.
        """
        self.irec.id = id

        return await self.exec()

    async def exec(self, irec: tBatchKey = None) -> "dBatchLockOne":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("BatchLockOne", self._dbcon.STMNT_TYPE_READ)

        self._dbstmnt.sql("""select
  id,
  parent_id,
  name,
  group_id,
  status,
  cycle,
  run_date,
  run_interval,
  run_time,
  ext_data,
  stamp_by,
  stamp_tm
from
  monitor.Batch
where
  id = :id for update nowait""")

        self._dbstmnt.bind_in("id", self.irec.id, int, 8)

        self._dbstmnt.bind_out("id", int, 8)
        self._dbstmnt.bind_out("parent_id", int, 8)
        self._dbstmnt.bind_out("name", str, 256)
        self._dbstmnt.bind_out("group_id", str, 128)
        self._dbstmnt.bind_out("status", str, 1)
        self._dbstmnt.bind_out("cycle", str, 1)
        self._dbstmnt.bind_out("run_date", datetime.datetime)
        self._dbstmnt.bind_out("run_interval", int, 4)
        self._dbstmnt.bind_out("run_time", str, 6)
        self._dbstmnt.bind_out("ext_data", dict)
        self._dbstmnt.bind_out("stamp_by", str, 128)
        self._dbstmnt.bind_out("stamp_tm", datetime.datetime)

        await self._dbcon.lock(self._dbstmnt)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

    async def fetch(self) -> bool:
        """
        Fetches the next row from the executed query.

        :return: True if a row is retreived.
        """
        if not await self._dbcon.fetch(self._dbstmnt):
            return False

        self.orec.id = self._dbstmnt.result[0]
        self.orec.parent_id = self._dbstmnt.result[1]
        self.orec.name = self._dbstmnt.result[2]
        self.orec.group_id = self._dbstmnt.result[3]
        self.orec.status = self._dbstmnt.result[4]
        self.orec.cycle = self._dbstmnt.result[5]
        self.orec.run_date = self._dbstmnt.result[6]
        self.orec.run_interval = self._dbstmnt.result[7]
        self.orec.run_time = self._dbstmnt.result[8]
        self.orec.ext_data = self._dbstmnt.result[9]
        self.orec.stamp_by = self._dbstmnt.result[10]
        self.orec.stamp_tm = self._dbstmnt.result[11]

        return True

    async def fetch_all(self, outList: tBatch.List, clearList: bool = True) -> int:
        """
        Fetch all the rows into the specified list and return the list count.

        :param outList:
        :param clearList:
        :return: Number of rows fetched.
        """
        if clearList:
            outList.clear()

        while await self.fetch():
            outList.append(copy.deepcopy(self.orec))

        return len(outList)

