# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#  Target Database = postgresql
#
import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from bs_monitor.db.tables.job_inst_cancel import tJobInstCancel

class dJobInstCancelInsert:

    def __init__(self, dbcon: mettle.db.IAConnect):
        """
        Constructor.

        :param dbcon: Mettle database connection object.
        """
        self._dbcon   = dbcon
        self._dbstmnt = None
        self.irec     = tJobInstCancel()

    def __del__(self):
        """
        Destructor.
        """
        del self._dbstmnt

    def __enter__(self):
        """
        With statement enter.
        """
        return self

    def __exit__(self, type, value, traceback):
        """
        With statement exit.
        """
        self._destroy()

    def _destroy(self):
        if self._dbstmnt == None:
            return

        del self._dbstmnt
        self._dbstmnt = None

    async def exec_deft(self,
                        jobinst_id: int,
                        reason: str,
                        stamp_by: str,
                        stamp_tm: datetime.datetime) -> "dJobInstCancelInsert":
        """
        Execute the query by setting all the inputs.

        :param jobinst_id: int
        :param reason: str
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        :return: Self for convenience.
        """
        self.irec.jobinst_id = jobinst_id
        self.irec.reason = reason
        self.irec.stamp_by = stamp_by
        self.irec.stamp_tm = stamp_tm

        return await self.exec()

    async def exec(self, irec: tJobInstCancel = None) -> "dJobInstCancelInsert":
        """
        Execute the query, optionally passing in the input rec.

        :param irec:
        :return: Self for convenience.
        """
        if irec:
            self.irec._copy_from(irec)

        self._destroy()

        self._dbstmnt = await self._dbcon.statement("JobInstCancelInsert", self._dbcon.STMNT_TYPE_CUD)

        self._dbstmnt.sql("""insert into monitor.JobInstCancel (
  jobinst_id,
  reason,
  stamp_by,
  stamp_tm
) values (
  :jobinst_id,
  :reason,
  :stamp_by,
  :stamp_tm
)""")

        self.irec.stamp_tm = await self._dbcon.get_timestamp()

        self._dbstmnt.bind_in("jobinst_id", self.irec.jobinst_id, int, 8)
        self._dbstmnt.bind_in("reason", self.irec.reason, str)
        self._dbstmnt.bind_in("stamp_by", self.irec.stamp_by, str, 128)
        self._dbstmnt.bind_in("stamp_tm", self.irec.stamp_tm, datetime.datetime)

        await self._dbcon.execute(self._dbstmnt)

        if irec:
            irec._copy_from(self.irec)

        return self

