# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

from .batch_item_key import tBatchItemKey

class tBatchItem(mettle.io.ISerializable, mettle.db.IPrimaryKey):

    def __init__(self,
                 id: int = 0,
                 batch_id: int = 0,
                 job_id: int = 0,
                 extra_args: str = '',
                 stamp_by: str = ''):
        """
        Constructor.

        :param id: int
        :param batch_id: int
        :param job_id: int
        :param extra_args: str
        :param stamp_by: str
        :param stamp_tm: datetime.datetime
        """
        self.id = id
        self.batch_id = batch_id
        self.job_id = job_id
        self.extra_args = extra_args
        self.stamp_by = stamp_by
        self.stamp_tm = None

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.id = 0
        self.batch_id = 0
        self.job_id = 0
        self.extra_args = ''
        self.stamp_by = ''
        self.stamp_tm = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'tBatchItem'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int64("id", self.id)
        _w.write_int64("batch_id", self.batch_id)
        _w.write_int64("job_id", self.job_id)
        _w.write_string("extra_args", self.extra_args)
        _w.write_string("stamp_by", self.stamp_by)
        _w.write_datetime("stamp_tm", self.stamp_tm)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.id = _r.read_int64("id")
        self.batch_id = _r.read_int64("batch_id")
        self.job_id = _r.read_int64("job_id")
        self.extra_args = _r.read_string("extra_args")
        self.stamp_by = _r.read_string("stamp_by")
        self.stamp_tm = _r.read_datetime("stamp_tm")
        _r.read_end(_oname)

    def _copy_from(self, rec: "tBatchItem"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.id = rec.id
        self.batch_id = rec.batch_id
        self.job_id = rec.job_id
        self.extra_args = rec.extra_args
        self.stamp_by = rec.stamp_by
        self.stamp_tm = rec.stamp_tm

    def _write_pk(self, _key: "tBatchItem"):
        """
        Write the primary key columns to the key object.

        :param _key:
        """
        self._write_key(_key)

    def _read_pk(self, _key: "tBatchItem"):
        """
        Read the primary key columns from the key object.

        :param _key:
        """
        self._read_key(_key)

    def _serialize_key(self, _w: mettle.io.IWriter):
        """
        Serialize the primary key to a stream.

        :param _w:
        """
        _key = tBatchItemKey()

        self._write_key(_key)
        _key._serialize(_w)

    def _deserialize_key(self, _r: mettle.io.IReader):
        """
        Deserialize the primary key from a stream.

        :param _r:
        """
        _key = tBatchItemKey()

        _key._deserialize(_r)
        self._read_key(_key)

    @staticmethod
    def _cache_davs(dvc=None, for_ins: bool = False, key_only: bool = False):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        :param for_ins: Davs for insert.
        :param key_only: Davs by key only, ie for delete/selectone.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("batch_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        if key_only:
            return dvc

        dvc.add_targ("job_id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("extra_args", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))
        dvc.add_targ("stamp_by", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("stamp_by", mettle.lib.Dav(mettle.lib.Dav.eDavType.Max, 128))

        return dvc

    def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
        tBatchItem._cache_davs(dvc, for_ins, key_only)

    def _write_key(self, _key: tBatchItemKey):
        """
        Write primary key columns to _key.

        :param _key:
        """
        _key.id = self.id
        _key.batch_id = self.batch_id

    def _read_key(self, _key: tBatchItemKey):
        """
        Read the primary key columns from _key.

        :param _key:
        """
        self.id = _key.id
        self.batch_id = _key.batch_id

    @staticmethod
    def _pk_compare(x, y) -> int:
        """
        Compare function do primary key comparisons for list sorts and searches.

        :return: zero for x == y, negative for x < y, positive for x > y
        """
        rc = x.id - y.id

        if rc != 0:
            return rc

        rc = x.batch_id - y.batch_id

        return rc

    def __lt__(self, other):
        return other and self._pk_compare(self, other) < 0

    def __gt__(self, other):
        return other and self._pk_compare(self, other) > 0

    def __eq__(self, other):
        return other and self._pk_compare(self, other) == 0

    def __le__(self, other):
        return other and self._pk_compare(self, other) <= 0

    def __ge__(self, other):
        return other and self._pk_compare(self, other) >= 0

    def __ne__(self, other):
        return other == None or self._pk_compare(self, other)

    def __repr__(self) -> str:
        return '<BatchItem [id:%r, batch_id:%r, job_id:%r, extra_args:%.32s, stamp_by:%.32s, stamp_tm:%s]>' % (
            self.id, self.batch_id, self.job_id, self.extra_args, self.stamp_by, self.stamp_tm)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'tBatchItem.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = tBatchItem()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<tBatchItem.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None, for_ins: bool = False, key_only: bool = False):
            return tBatchItem._cache_davs(dvc, for_ins, key_only)

