# This file was generated by mettle.genes.db.GenPy3 [ver 2.1] on Tue Mar 22 16:51:11 2022
#

import copy
import datetime
import uuid
import time
import mettle.lib
import mettle.io
import mettle.db

class iBatchInstNotCompleted(mettle.io.ISerializable):

    def __init__(self,
                 batch_id: int = 0,
                 sys_date: datetime.datetime = None):
        """
        Constructor.

        :param batch_id: int
        :param sys_date: datetime.datetime
        """
        self.batch_id = batch_id
        self.sys_date = sys_date

    def clear(self):
        """
        Clears all member variables for this database record.
        """
        self.batch_id = 0
        self.sys_date = None

    def _name(self) -> str:
        """
        Name of the record.

        :return: The name.
        """
        return 'iBatchInstNotCompleted'

    def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
        """
        Serialize record to a stream.

        :param _w:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _w.write_start(_oname)
        _w.write_int64("batch_id", self.batch_id)
        _w.write_datetime("sys_date", self.sys_date)
        _w.write_end(_oname)

    def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
        """
        Deserialize record from a stream.

        :param _r:
        :param _oname:
        """
        if _oname == None:
            _oname = self._name()

        _r.read_start(_oname)
        self.batch_id = _r.read_int64("batch_id")
        self.sys_date = _r.read_datetime("sys_date")
        _r.read_end(_oname)

    def _copy_from(self, rec: "iBatchInstNotCompleted"):
        """
        Copies the column from the rec into this record.

        :param rec: The source record.
        """
        self.batch_id = rec.batch_id
        self.sys_date = rec.sys_date

    @staticmethod
    def _cache_davs(dvc=None):
        """
        Cache the DAV into the dav cache (or create one) and return it.

        :param dvc: (mettle.lib.DavCache), target cache, if None a new one is created and returned.
        """
        if dvc is None:
            dvc = mettle.lib.DavCache()

        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.Min, 1))
        dvc.add_targ("id", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))
        dvc.add_targ("sysDate", mettle.lib.Dav(mettle.lib.Dav.eDavType.NotNull))

        return dvc

    def _get_davs(self, dvc=None):
        iBatchInstNotCompleted._cache_davs(dvc)

    def __repr__(self) -> str:
        return '<BatchInst [batch_id:%r, sys_date:%s]>' % (
            self.batch_id, self.sys_date)


    class List(list, mettle.io.ISerializable):
        """
        List Class
        """

        def _name(self) -> str:
            """
            Name of the list.

            :return: The name
            """
            return 'iBatchInstNotCompleted.List'

        def _serialize(self, _w: mettle.io.IWriter, _oname: str = None):
            """
            Serialize the list to a stream.

            :param _w:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _w.write_start_list(_oname, len(self))

            for _rec in self:
                _rec._serialize(_w)

            _w.write_end(_oname)

        def _deserialize(self, _r: mettle.io.IReader, _oname: str = None):
            """
            Deserialize the list from a stream.

            :param _r:
            :param _oname:
            """
            if _oname == None:
                _oname = self._name()

            _cnt = _r.read_start_list(_oname)

            while _cnt >= 1:
                _rec  = iBatchInstNotCompleted()
                _cnt -= 1
                _rec._deserialize(_r)
                self.append(_rec)

            _r.read_end(_oname)

        def __repr__(self) -> str:
            return '<iBatchInstNotCompleted.List[%d]>' % (len(self))

        def _get_davs(self, dvc=None):
            return iBatchInstNotCompleted._cache_davs(dvc)

